/**
 * HTML template cache
 */

var cache = {};

function get(name)
{
	return cache[name];
}

function execute(name, model, params)
{
	return cache[name](model, params);
} 

function set(name, data)
{
	cache[name] = data;
}

function has(name)
{
	return (name in cache);
}

function remove(name)
{
	delete cache[name];
}

exports.get = get;
exports.execute = execute;
exports.set = set;
exports.has = has;
exports.remove = remove;