/**
 * DEPRECATED - Scan and load controllers
 */

"use strict";

require("../utils/annotation");

let readdirp = require("readdirp");
let configs = require("../conf/configs");
let controllerProcessor = require("./processor");

let result = {};

exports.loadController = (path) =>
{
	let Controller = require(path);
	if (!Controller.hasAnnotation("controller")) {
		return;
	}

	let info = Controller.getAnnotationData("controller");
	let c = new Controller();
	let controllerData = {
		controller: c,
		path: path
	};

	if (result[info.urlPattern]) {
		return;
	}

	result[info.urlPattern] = controllerData;

	console.info("Loaded controller at " + path);

	if (typeof(c.init) === "function") {
		c.init({
			configs: configs
		});
	}

	if (configs.precompileViews === true) {
		let doProcessView = (viewInfo) => {
			controllerProcessor.processView(viewInfo, controllerData.path, {}, {}, true, (err, data) => {
				if (err) {
					console.error("Error occured when compiling view page " + viewInfo.path);
					console.error(err);
					return;
				}

				console.info("Pre-compiled view page " + viewInfo.path + " for controller " + controllerData.path);
			});
		};

		for (let key of Object.keys(c)) {
			if (typeof(c[key]) !== "function") {
				continue;
			}

			let func = c[key];
			if (!func.hasAnnotation("view")) {
				continue;
			}

			let viewInfo = func.getAnnotationData("view");
			doProcessView(viewInfo);
		}
	}
};

exports.getControllerList = () =>
{
	return result;
};
