"use strict";

let Service = require("./service");
let WebSocketServer = require("ws").Server;

class WebSocketService extends Service
{
    constructor() {
        super();

        this._service.handoff = true;
    }

    init() {
        this._wss = new WebSocketServer({ port: this._service.port });
        this._wss.on("connection", (ws) => {
            this.onConnected(ws);

            ws.on("ping", () => ws.pong());

            ws.on("message", (msg) => this.dispatch(ws, msg));

            ws.on("open", () => {
                console.info("A WebSocket connection opened.");
            });

            ws.on("close", () => {
                console.info("A WebSocket connection closed.");
            });

            ws.on("error", (err) => {
                console.warn("Error occured on WebSocket connection: " + err.message);
                console.warn(err);
            });
        });

        this._wss.on("error", (err) => {
            console.warn("Error occured on WebSocket server: " + err.message);
            console.warn(err);
        });
    }

    dispatch(connnection, message) {

    }

    send(connection, message) {
        return new Promise((resolve, reject) => {
            try {
                connection.send(message, (err) => {
                    if (err) {
                        console.warn("Failed to send message '" + message + "' to WebSocket connection!");
                        reject(err);
                    } else {
                        //console.info("Sent message '" + message + "' to WebSocket connection.");
                        resolve();
                    }
                });
            } catch (e) {
                reject(e);
            }
        });
    }

    onConnected(connection) {

    }
}

module.exports = WebSocketService;
