var configs = require("../conf/configs");
var path = require("path");

function RenderUtils(viewPath)
{
	var resolvePath = function (p, delta) {
		var viewAbsDir = path.dirname(path.resolve(viewPath));
		var realPath = path.join(viewAbsDir, delta ? delta : "", p);
		var relPath = path.relative(path.resolve(configs.webRoot), realPath);

		if (path.resolve(relPath).indexOf(path.resolve(configs.webRoot)) !== 0) {
			return "/externalFileResolver?path=" + encodeURIComponent(relPath);
		}

		return "/" + relPath;
	};

	this.renderScript = function (p, delta) {
		return "<script type='text/javascript' src='" + resolvePath(p, delta) + "'></script>";
	};

	this.renderStyle = function (p, delta) {
		return "<link type='text/css' rel='stylesheet' href='" + resolvePath(p, delta) + "' />";
	};
}

module.exports = RenderUtils;
