"use strict";

let ViewTag = require("../../view-tag");

class HtmlTagBase extends ViewTag
{
    constructor(name, selfClosed) {
        super();

        this._name = name;
        this._selfClosed = selfClosed;
    }

    render(attrs, content) {
        let str = "<" + this._name;

        for (let a of Object.keys(attrs)) {
            str += " " + a + "=\"" + attrs[a] + "\"";
        }

        if (this._selfClosed) {
            str += " />\n";
        } else {
            str += ">" + content + "</" + this._name + ">\n";
        }

        return str;
    }
}

module.exports = HtmlTagBase;
