"use strict";

let ViewTag = require("../view-tag");
let ViewTagUtils = require("../view-tag-utils");
let Util = require("util");
let path = require("path");

class ModelTag extends ViewTag
{
    render(attrs, content) {
        return ViewTagUtils.putDeferredVariable(attrs.name || "model", (context, moduleName, funcName) => {
            return new Promise((resolve, reject) => {
                let m = global.__node_bubble_view_models__[moduleName];
                if (typeof m[funcName] !== "function") {
                    return reject(new Error("View model action " + funcName + " in module " + moduleName + " is not a function!"));
                }

                m[funcName](context).then((data) => resolve(data)).catch((err) => reject(err));
            });
        }, attrs.module, attrs.action);
    }
}

module.exports = ModelTag;
