"use strict";

let ViewTagUtils = require("./view-tag-utils");
let xmldoc = require("xmldoc");

class ViewTag
{
	constructor() {
		this._content = "";
	}

	render(attrs, content) {
		return content;
	}

	getPart(name) {
		if (this._content.indexOf("<bview:part-" + name + ">") < 0) {
			return null;
		}
		
		let r = new RegExp("<bview:part-" + name + ">([\\s\\S]*?)</bview:part-" + name + ">");
		let arr = this._content.split(r);
		let p = arr[1];

		return p;
	}

	_render(attrs, content, deferredList, viewDir, tagDir) {
		this._content = content;

		let data = this.render(attrs, content, viewDir, tagDir);
		let renderedContent = "";

		if (typeof data === "string") {
			renderedContent = data;
		} else if (data instanceof ViewTagUtils.DeferredValue) {
			deferredList.push({ functor: data.functor, params: data.params });
			let i = deferredList.length - 1;
			renderedContent = "${ yield deferredList[" + i + "].functor.apply(null, [ context ].concat(deferredList[" + i + "].params)) }$";
		} else if (data instanceof ViewTagUtils.DeferredVariable) {
			deferredList.push({ functor: data.functor, params: data.params });
			let i = deferredList.length - 1;
			renderedContent = "<!--[ var " + data.varName + " = yield deferredList[" + i + "].functor.apply(null, [ context ].concat(deferredList[" + i + "].params)); ]-->";
		}

		return {
			content: renderedContent,
			deferredList: deferredList
		}
	}
}

module.exports = ViewTag;
